SystemOrganization addCategory: #'Compiler-Debugger'!

Object subclass: #MethodMapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Debugger'!

!MethodMapper class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/13/2011 14:13'!
forMethod: aCompiledMethod
	^self subclassResponsibility! !

!MethodMapper methodsFor: 'accessing' stamp: 'EstebanAllende 12/13/2011 14:02'!
namedTempAt: index in: aContext
	"Answer the value of the temp at index in aContext where index is relative
	 to the array of temp names answered by tempNamesForContext:"
	^self subclassResponsibility.! !

!MethodMapper methodsFor: 'accessing' stamp: 'EstebanAllende 12/13/2011 14:03'!
namedTempAt: index put: aValue in: aContext
	"Assign the value of the temp at index in aContext where index is relative
	 to the array of temp names answered by tempNamesForContext:.
	 If the value is a copied value we also need to set it along the lexical chain."
	^self subclassResponsibility.! !

!MethodMapper methodsFor: 'source mapping' stamp: 'EstebanAllende 12/13/2011 14:04'!
rangeForPC: concretePC contextIsActiveContext: contextIsActive
  "Answer the indices in the source code for the supplied pc."
	^self subclassResponsibility.! !

!MethodMapper methodsFor: 'source mapping' stamp: 'EstebanAllende 12/13/2011 14:35'!
sourceText
	^self subclassResponsibility.! !

!MethodMapper methodsFor: 'accessing' stamp: 'EstebanAllende 12/13/2011 14:03'!
tempNamesForContext: aContext
	"Answer an Array of all the temp names in scope in aContext starting with
	 the home's first local (the first argument or first temporary if no arguments)."
	^self subclassResponsibility.! !

!MethodMapper methodsFor: 'accessing' stamp: 'EstebanAllende 12/13/2011 14:03'!
tempNamesScopedForContext: aContext
	"Answer an Array of all the temp names in scope in aContext starting with
	 the home's first local (the first argument or first temporary if no arguments)."
	^self subclassResponsibility.! !

!MethodMapper methodsFor: 'accessing' stamp: 'EstebanAllende 12/13/2011 14:04'!
tempsAndValuesForContext: aContext
	"Return a string of the temporary variabls and their current values"
	^self subclassResponsibility.! !
